<?php
/*
 * Copyright(C) 2003-2005, 2007 op5 AB
 * All rights reserved.
 *
 */

define('SKIP_KOHANA', true);
require('/opt/monitor/op5/ninja/index.php');

require_once('include/webconfig.inc.php');
require_once('include/config.inc.php');
require_once('include/autoscan.inc.php');
require_once('classes/common_gui.php');

$page->html_start("Network autoscan config");
if(!in_array(NACOMA_ACCESS_FULL_ACCESS, get_nacoma_access('configuration_information'))) {
  $page->html_start();
  deny_access("You are not authorized to configure autoscans.");
}
if (!host_nacoma_Model::can_user_write('new')) {
  $page->html_start('');
  deny_access("You are not allowed to create new hosts.");
}


echo "<p>Network ranges can be specified in a very free form.\n" .
  "Each of the four parts of the IP-address may contain any\n" .
  "combination of comma-separated numbers, 'from-to' ranges\n" .
  "and single numbers, as such: <strong>10.1,2.0,4-10.1-50</strong>.<br />\n" .
  "You can specify multiple ranges, separated by spaces, if you like." .
  "</p>\n";
echo "<div class='note'><p>\n";
echo "<strong>Note:</strong> Only hosts responding to ICMP ECHO " .
  "requests (PING) will be detected.<br />\n";
echo "</p></div><br>\n";

$old_blacklist = autoscan_blacklist_get_list();
$new_blacklist = false;

if(isset($_REQUEST['delete']) && !empty($_REQUEST['delete'])) {
	$delscan = $_REQUEST['delete'];
	$scan_settings = autoscan_settings_get_by_id($delscan);
	$name = $scan_settings[0][4];
	echo "<b>Removing schedule scan '" . htmlspecialchars($name, ENT_QUOTES, 'UTF-8') . "'</b>\n";
	autoscan_settings_delete($delscan);
	autoscan_result_unref_unused($delscan);
	autoscan_result_delete_nonreferecned();
	autoscan_join_delete($delscan);
}
elseif(isset($_REQUEST['action']) && $_REQUEST['action'] === 'Apply') {
	if (isset($_REQUEST['new_criteria']) && isset($_REQUEST['new_name'])) {
		if (!empty($_REQUEST['new_criteria']) && !empty($_REQUEST['new_name'])) {
			echo "<b>Add new scan '" . htmlspecialchars($_REQUEST['new_name'], ENT_QUOTES, 'UTF-8') . "'</b>\n";
			autoscan_settings_add($_REQUEST['new_criteria'], $_REQUEST['new_name'], isset($_REQUEST['new_description']) ? $_REQUEST['new_description'] : "", (isset($_REQUEST['new_enabled']) && $_REQUEST['new_enabled'] == 'on' ? 1: 0));
		} elseif (!empty($_REQUEST['new_name'])) {
			// Show warning and highlight bad fields
			echo "<b>Please, specify IP Range to scan</b>\n";
		} elseif (!empty($_REQUEST['new_criteria'])) {
			// Show warning and highlight bad fields
			echo "<b>Please, specify scan NAME</b>\n";
		}
	}

	$queries = isset($_REQUEST['criteria']) ? $_REQUEST['criteria'] : array();
	$desc = isset($_REQUEST['description']) ? $_REQUEST['description'] : array();
	$enabled = isset($_REQUEST['enabled']) ? $_REQUEST['enabled'] : array();

	foreach ($queries as $id => $value) {
		autoscan_settings_update($id, $value, $desc[$id], ($enabled[$id] == 'on' ? 1: 0));
	}

	unset($queries);
	unset($desc);
	unset($enabled);

	$new_blacklist = isset($_REQUEST['blacklist']) ? $_REQUEST['blacklist'] : array();

	if (empty($new_blacklist))
		$new_blacklist = array();

	$del_blacklist = array_diff($old_blacklist, $new_blacklist);
	foreach ($del_blacklist as $address) {
		autoscan_blacklist_delete($address);
		autoscan_result_visibility_change($address, 1);
	}

	$add_blacklist = array_diff($new_blacklist, $old_blacklist);
	foreach ($add_blacklist as $address) {
		autoscan_blacklist_add($address);
		autoscan_result_visibility_change($address, 0);
	}
}

echo "</div></div><div id=\"object-table\">\n";

$page->form_start('autoscan', 'post');
?>
<div style="width: 98%; margin-left: 1%; margin-top: -25px">

<a name='New scan'></a>
<br /><table class='max'><tr><td class='CmdBar'>Host blacklist</td>
</tr>
</table><table class='max zebra' style="border-right: 1px solid #dcdccd; border-bottom: 1px solid #dcdccd">

<tr><td class='HelpList'>
<a style='border:0px none;' data-help='autoscan_blacklist' tabindex='-1' title='Click to view help on autoscan_blacklist' href='#'>
<img title='Help' alt='Help' src='images/icons/shield-help.png'></a></td>
<td class='VarList'>List</td>
<td>
<select class='multiple' size='4' multiple='multiple' id='blacklist' name='blacklist[]'>
<optgroup label='&nbsp;Hosts'>
<?php
if ($new_blacklist === false) {
	foreach ($old_blacklist as $address) {
		echo "<option value='" . $address . "'>" . $address . "</option>\n";
	}
} else {
	foreach ($new_blacklist as $address) {
		echo "<option value='" . $address . "'>" . $address . "</option>\n";
	}
}
?>
</optgroup></select>
</td></tr>

<tr><td class='HelpList'>
<a style='border:0px none;' data-help='autoscan_blacklist_host' tabindex='-1' title='Click to view help on autoscan_blacklist_host' href='#'>
<img title='Help' alt='Help' src='images/icons/shield-help.png'></a></td>
<td class='VarList'>Host</td>
<td>
<input type='text' size='32' id='blacklist_host' />
</td></tr>

<tr><td class='HelpList'>
<a style='border:0px none;' data-help='autoscan_blacklist_actions' tabindex='-1' title='Click to view help on autoscan_blacklist_actions' href='#'>
<img title='Help' alt='Help' src='images/icons/shield-help.png'></a></td>
<td class='VarList'>Actions</td>
<td>
<input type='button' title='Add' class='button add' value='Add' onclick="var blacklist = this.form.elements['blacklist'].options; var host = this.form.elements['blacklist_host'].value; var ip_addr = /^(((([0-9])|([1-9][0-9])|(1[0-9][0-9])|(2[0-4][0-9])|(25[0-5]))).){4}$/; if (ip_addr.test(host + '.')) { for (var i=0; i < blacklist.length; i++) if (blacklist[i].text == host) return; blacklist[blacklist.length] = new Option(host, host); }">
<input type='button' title='Remove' class='button remove' value='Remove' onclick="var blacklist = this.form.elements['blacklist']; while (blacklist.selectedIndex != -1) blacklist.remove(blacklist.selectedIndex);">
</td></tr>

</table>

<a name='New scan'></a>
<br /><table class='max'><tr><td class='CmdBar'>New scan</td>
</tr>
</table><table class='max zebra' style="border-right: 1px solid #dcdccd; border-bottom: 1px solid #dcdccd">

<tr><td class='HelpList'>
<a style='border:0px none;' data-help='autoscan_name' tabindex='-1' title='Click to view help on autoscan_name' href='#'>
<img title='Help' alt='Help' src='images/icons/shield-help.png'></a></td>
<td class='VarList'>Name</td>
<td>
<input type='text' size='32' name='new_name' />
</td></tr>

<tr><td class='HelpList'>
<a style='border:0px none;' data-help='autoscan_range' tabindex='-1' title='Click to view help on autoscan_range' href='#'>
<img title='Help' alt='Help' src='images/icons/shield-help.png'></a></td>
<td class='VarList'>IP Range</td>
<td>
<input type='text' size='32' name='new_criteria' />
</td></tr>

<tr><td class='HelpList'>
<a style='border:0px none;' data-help='autoscan_desc' tabindex='-1' title='Click to view help on autoscan_desc' href='#'>
<img title='Help' alt='Help' src='images/icons/shield-help.png'></a></td>
<td class='VarList'>Description</td>
<td>
<textarea name='new_description' rows='5' cols='41'></textarea>
</td></tr>

<tr><td class='HelpList'>
<a style='border:0px none;' data-help='autoscan_enabled' tabindex='-1' title='Click to view help autoscan_enabled' href='#'>
<img title='Help' alt='Help' src='images/icons/shield-help.png'></a></td>
<td class='VarList'>Active</td>
<td>
<input type='checkbox' name='new_enabled' checked='checked' />
</td></tr>

</table>

<?php
//SELECT id, count, epoch, criteria, name, description, enabled FROM autoscan_settings
$list = autoscan_settings_get_list();
foreach ($list as $row) {
	$scan_id = $row[0];
	$scan_criteria = $row[3];
	$scan_name = $row[4];
	$scan_desc = $row[5];
	$scan_enabled = $row[6];
	echo "<a name='" . htmlspecialchars($row[4], ENT_QUOTES, 'UTF-8') . "'></a>\n";

	// one table around it all, and the one we are inside.
	echo "<br /><table class='max'><tr><td class='CmdBar'>\n";
	echo htmlspecialchars($scan_name, ENT_QUOTES, 'UTF-8') . "\n";
	echo "</td>\n";

	echo "<td class='CmdBarItem'>\n";
	echo "<a href='".htmlspecialchars($_SERVER['PHP_SELF'], ENT_QUOTES, 'UTF-8')."?delete=" . $scan_id . "'>delete</a></td>\n";

	echo "</tr>\n";
	echo "</table><table class='max zebra' style=\"border-right: 1px solid #dcdccd; border-bottom: 1px solid #dcdccd\">\n";

	echo "<tr><td class='HelpList'>\n";
	echo "<a style='border:0px none;' data-help='autoscan_range' tabindex='-1' title='Click to view help on timeperiod_name' href='#'>\n";
	echo "<img title='Help' alt='Help' src='images/icons/shield-help.png'></a></td>\n";
	echo "<td class='VarList'>IP Range</td>\n";
	echo "<td>\n";
	echo "<input type='text' size='32' name='criteria[" . $scan_id . "]' value='" . htmlspecialchars($scan_criteria, ENT_QUOTES, 'UTF-8') . "' />\n";
	echo "</td></tr>\n";

	echo "<tr><td class='HelpList'>\n";
	echo "<a style='border:0px none;' data-help='autoscan_desc' tabindex='-1' title='Click to view help on timeperiod_name' href='#'>\n";
	echo "<img title='Help' alt='Help' src='images/icons/shield-help.png'></a></td>\n";
	echo "<td class='VarList'>Description</td>\n";
	echo "<td>\n";
	echo "<textarea name='description[" . $scan_id . "]' rows='5' cols='41'>" . $scan_desc . "</textarea>\n";
	echo "</td></tr>\n";

	echo "<tr><td class='HelpList'>\n";
	echo "<a style='border:0px none;' data-help='autoscan_enabled' tabindex='-1' title='Click to view help on timeperiod_name' href='#'>\n";
	echo "<img title='Help' alt='Help' src='images/icons/shield-help.png'></a></td>\n";
	echo "<td class='VarList'>Active</td>\n";
	echo "<td>\n";
	echo "<input type='checkbox' name='enabled[" . $scan_id . "]'";
	if($scan_enabled)
		echo " checked='checked'";
	echo " /></td></tr>\n";

	echo "</table>\n";
}
unset($result);
$page->submit_button('Apply');
echo '</div>';
$page->form_end();
$page->html_end();
