<?php

define('SKIP_KOHANA', true);
require('/opt/monitor/op5/ninja/index.php');

require_once('classes/common_gui.php');
require_once('include/help.inc.php'); // help strings

# This should only happen when someone goes through
# help_index.php.
if (!$input->obj_type) {
	require_once('docs/help.php');
	$page->html_end();
}

// vars to show
$variables 	= @$_GET['page_vars'];


// the page we are displaying help for
$pagename	= $_GET['page'];

$obj_type	= $_GET['obj_type'];

if($obj_type == 'timeperiod')
{
	$variables = array
	(
		'timeperiod_name',
		'alias',
		'weekday',
		'exception',
		'exclude'
	);
}
// lang might be user specific in later release and be an
// array of browser detected languages
$aLang 		= 'en';

// If we need to switch to default lang (en) later on
// as we might not support all languages...
$sel_lang 	= $aLang;

// Variables for object type $obj_type
if (isset($page_vars[$sel_lang][$pagename][$obj_type]) && is_array($page_vars[$sel_lang][$pagename][$obj_type])){
	extract($page_vars[$sel_lang][$pagename][$obj_type]);
} else {
	//echo "<br /><b>== Page variables missing ==</b><br />";
}

// Common page variables
if (is_array($page_vars[$sel_lang][$pagename]['common'])){
	extract($page_vars[$sel_lang][$pagename]['common']);
} else {
	echo "<br /><b>== Common variables missing ==</b><br />";
}
$_help_description = isset($_help_description) && !empty($_help_description) ? $_help_description : '';
$_help_content = isset($_help_content) && !empty($_help_content) ? $_help_content : '';
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">

<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
	<head>
		<meta http-equiv="Content-type" content="application/xhtml+xml; charset=utf-8" />
		<meta http-equiv="Pragma" content="no-cache" />
		<meta http-equiv="Pragma-directive" content="no-cache" />
		<meta http-equiv="Cache-directive" content="no-cache" />
		<meta http-equiv="Expires" content="0" />
		<title> op5 Monitor &raquo; <?php echo $_help_page_title.$obj_type ?></title>
		<link type="text/css" rel="stylesheet" href="css/tables.css" />
		<link type="text/css" rel="stylesheet" href="css/help.css" />
		<link type="text/css" rel="stylesheet" href="css/webconfig.css" />
		<link type="text/css" rel="stylesheet" href="css/help.css" />
		<script type="text/javascript" type="text/javascript" src="js/helptexts.js"></script>
		<script type="text/javascript" type="text/javascript" src="js/help.js"></script>
		<script type="text/javascript">
		var DEBUG = <?php echo (int)$DEBUG ?>;
		</script>
	</head>
<body onload="self.focus();<?php echo (is_array($variables)) ? "printHelp('helpTable', '".implode("', '", $variables)."');" : "" ?>">
		<div id="content" style="padding: 15px">
			<h1><span id="_help_page_title"><?php echo $_help_page_title.$obj_type ?></span> </h1>
			<p style="width: auto"><span style="width: auto"id="_help_page_info"><?php echo nl2br($_help_page_info) ?><br />

			<span id="_help_description"><?php echo nl2br($_help_description) ?></span><br />
			<span id="_help_content"><?php echo nl2br($_help_content) ?></span>
			<?php if ((is_array($variables))){ ?><img src="images/icons/arrow.gif" alt="" /> <a href="#" onclick="toggleVarHelp('helpTable');return false;" id="toggle" title="Toggle display of variable info">Hide variables</a><?php } ?>
			</p>
		</div>

		<?php if (is_array($variables)){ ?>
		<div id="helpTable"></div>
		<?php } ?>
	</body>
</html>
