#!/usr/bin/env python2

import sys

from nacoma.hooks import Change


def main():
	for line in sys.stdin:
		change = Change(line)
		if change.is_renamed():
			if change.type == 'host' or change.type == 'service':
				print('<span style="font-weight: bold;">')
				print('A host/service was renamed. Additional steps are required to complete this action.<br />')
				print('For more information, see the <a href="https://docs.itrsgroup.com/docs/op5-monitor/current/topics/admin-manual/plugins/plugins.html" target="_blank">op5 Monitor Administrator Manual</a>')
				print('<span class="ui-icon ui-icon-newwin" style="display: inline-block; cursor: pointer"></span>')
				print(' (Renaming a host).<br />')
				print('<br /></span>')
				sys.exit()

if __name__ == '__main__':
    main()
