<?php

function format_access_right( $name ) {
	return htmlentities( ucwords( str_replace( '_', ' ', $name ) ) );
}

foreach($page->get_flashed_messages() as $message) {
	echo "<p>$message</p>";
}

?>

<p><strong>Set the groups' access levels.</strong></p>
<p>In order to define any user's rights, a user must be categorized as a certain type of user, which is done by giving them group membership. You handle group membership in the <a href="edit_special.php/access">local users administration</a>.<p>
<p>If you want to make an exempt from the group based system and grant a special right to a certain user, you create a group below with a name like <strong>user_john</strong> if <strong>john</strong> is the user you want to treat specially. Beware that this kind of special treatment often leads to an inconsequent environment for you to manage later on, which is why <strong>we recommend you to mostly use group based rights</strong>.<p>
<!-- hehe, here's that nomad div-tag.. @todo remove -->
<br />
<br />
</div>
<div id="filter_and_search" style="clear: both;">
	<div class="" style="float: left;">
		<h2>Lookup user <img src='images/icons/shield-help.png' class='group_help_icon' style='cursor: help;' alt='lookup_user' title='lookup_user' /></h2>
		<form target="#" id="user_lookup_form">
			<input type="text" id="highlight_user" name="highlight_user" value="">
			<input type="submit" value="Lookup">
		</form>
		<div id="highlight_user_loading" style="display: none;"> Loading...</div>
		<div id="highlight_user_groups">&nbsp;</div>
	</div>
	<div class="" style="float: left;">
		<h2>Filter groups <img src='images/icons/shield-help.png' class='group_help_icon' style='cursor: help;' alt='filter_groups' title='filter_groups' /></h2>
		<form target="#" id="filter_groups_form">
			<input type="text" id="group_filter_box" name="group_filter_box" value="">
			<input type="submit" value="Filter Groups">
		</form>
	</div>
</div>
<div id='object-table'>
<form action="?action=submit" method="post">
<table class="ObjTable zebra" style="border-left: 0px">
<tr class="headerGroupRights access_header">
<td class="no_tooltip">
</td>
<?php
foreach( $group_available as $be_name => $avalibility ) {
	echo '<td class="auth_driver"><span>'.htmlentities($be_name).'</span></td>';
}
foreach( $access_rights as $category => $ary ) {
	echo '<td><span>'.format_access_right($category).'</span></td>';
	foreach( $ary as $name => $descr ) {
		echo '<td class="'.$category.'"><span>'.format_access_right($name).'</span></td>';
	}
}
?>
</tr>
<tr id="category_expand">
<td style="white-space:nowrap;"><input type="button" id="expand_all_button" value="Expand All"><input type="button" id="contract_all_button" value="Contract All"></td>
<?php
for($cnt = count($group_available); $cnt > 0; $cnt--) {
	echo '<td></td>';
}

foreach( $access_rights as $category => $ary ) {
	echo '<td><input type="button" class="expand_button" id="' . $category . '" value="-"></td>';
	foreach ($ary as $name => $descr ) {
		echo '<td class="' . $category . '">&nbsp;</td>';
	}
}
foreach ($groups as $name => $perms) {
	$perms = (array) $perms; // might be a string
	$group64=base64_encode($name); ?>

	<tr style='text-align: center;'>

	<td style='text-align: left;'>
		<input type="text" name="name[<?php echo $group64; ?>]" value="<?php echo htmlentities( $name, ENT_COMPAT, 'UTF-8' ); ?>" class="group_field" onchange="clear_highlights();">
	</td>
<?php
	foreach( $group_available as $be_name => $avalibility ) {
		if( !isset( $avalibility[$name] ) ) {
			echo '<td style="background-color: #999999">';
		} else if( $avalibility[$name] ) {
			echo '<td style="background-color: #00FF00">';
		} else {
			echo '<td style="background-color: #FF6655">';
		}
		echo '<span class="backendmarker backendmarker_'.$be_name.'" style="display: none;">X</span>';
		echo '</td>';
	}
	foreach( $access_rights as $category => $ary ) {
		echo "<td class=\"checkbox_category\"><input data-category=\"$category\" type=\"checkbox\" class=\"{$category}_tristate\"></td>";
		foreach( $ary as $name => $descr ) {
?>
			<td class="checkbox_cell <?php echo $category ?>">
				<input
					data-category="<?php echo $category ?>"
					type="checkbox"
					name="access_right[<?php echo $group64; ?>][<?php echo $name ?>]"
					<?php echo in_array( $name, $perms ) ? ' checked="checked"' : null ?> />
			</td>
<?php
		}
	}
	echo "</tr>\n\n";
}
?>

<tr style='text-align: center;'>

	<td style='text-align: left;'>
		<input type="text" name="name[new]" value="">
	</td>
	<?php
	foreach( $group_available as $be_name => $avalibility ) {
		echo '<td><span class="backendmarker backendmarker_'.$be_name.'" style="display:none">X</span></td>';
	}
	foreach( $access_rights as $category => $ary ) {
		echo "<td class=\"checkbox_category\"><input data-category=\"$category\" type=\"checkbox\" class=\"{$category}_tristate\"></td>";
		foreach( $ary as $name => $descr ) { ?>
			<td class="checkbox_cell <?php echo $category; ?>">
				<input
					data-category="<?php echo $category ?>"
					type="checkbox"
					name="access_right[new][<?php echo $name; ?>]">
			</td>
		<?php }
	} ?>
</tr>
</table>

<div class="max magic">
	<input type="submit" id="Save" value="Save" class="object-submit" />
</div>
</form>



</div>
<?php $page->html_end();

