<?php

/**
 * Commands are executed on each check and consists of
 * a program and it's command line arguments.
 */
class command_nacoma_Model extends naemon_nacoma_Model
{
	/** object type */
	const TYPE = 'command';

	public $properties = array (
		'topic' => 'command_name',
		'var_index' => array (
			'command_name' => 'string',
			'command_line' => 'string',
			'file_id' => 'select',
			'register' => 'bool'
		),
		'widget' => array (
			'register' => 'hidden'
		),
		'required' => array (
			'command_name',
			'command_line',
			'file_id'
		),
		'default' => array (
			'file_id' => 'etc/checkcommands.cfg'
		),
		'special' => array (
			'file_id' => 'FILE'
		)
	);

	/**
	 * Return the mayi resource for the object
	 * @see object_nacoma_Model::mayi_resource()
	 */
	public function mayi_resource() {
		return "monitor.monitoring.commands";
	}

	/**
	 * Export with naming and values to map nagios struct names ond format
	 *
	 * Useful for Test this x operation
	 */
	public function get_nagios_struct($prefix='') {
		$this->expand_object();
		$obj = $this->denormalize();
		return array(
				$prefix . 'name' => $obj['command_name'],
				$prefix . 'command_line' => $obj['command_line'],
				);
	}

	protected function get_reasons_to_not_delete(&$all, &$hard) {
		if (isset($this->obj['command_name']) &&
			$this->obj['command_name'] === 'bizproc_pas') {

			// bizproc_pas is needed by BSM and should not be able to be
			// deleted. Unfortunately there is no other way to know that
			// in Nacoma other than to look at the name.
			// Also @see service_template_nacoma_Model::get_reasons_to_not_delete()

			$reason = '"bizproc_pas" is needed by BSM and cannot be deleted.';
			$all[$this->type] = array();
			$all[$this->type][$this->id] = $reason;
			$hard[$this->type] = array();
			$hard[$this->type][$this->id] = $reason;

			// Avoid running parents get_reasons_to_not_delete().
			// It will destroy $all and $hard.
			return;
		}
		parent::get_reasons_to_not_delete($all, $hard);
	}
}
