<?php

Event::add('system.post_controller_constructor', function() {
	$controller = Event::$data;
	/*
	 * We can only add notifications to the ninja controller, so don't bother
	 * otherwise
	 */
	if (!$controller instanceof Controller) {
		// checking for the general Kohana-construct "Controller"
		// first. The Cli_Controller, for example, inherits Controller
		// not Ninja_Controller. Cli_Controller is not attached to the
		// GUI so it shouldn't be notified in the GUI, but not passing
		// a Controller to this event would be a real error worth
		// checking out.
		$type = gettype($controller);
		if($type === 'object') {
			$type = get_class($controller);
		}
		op5log::instance('nacoma')->log('error', sprintf("Tried to run autoscan hook but event data wasn't a Controller but a '%s'", $type));
		return;
	}
	if (!$controller instanceof Ninja_Controller) {
		// only Ninja controllers should have a notification
		return;
	}
	$user = Auth::instance()->get_user();
	if (nacoma::link() === true &&
		 $user->authorized_for('configuration_information') &&
		 $user->authorized_for('system_commands') &&
		 $user->authorized_for('host_view_all')) {

		$nacoma = Database::instance('nacoma');
		$query = $nacoma->query(
			'SELECT COUNT(id) AS cnt FROM autoscan_results WHERE visibility != 0');
		$query->result(false);
		$row = $query->current();
		if ($row !== false && $row['cnt'] > 0) {
			$controller->notices[] = new InformationNotice_Model(
				html::href(
					url::method("configuration", "configure", array(
						"scan" => "autoscan_complete"
					)),
					$row['cnt'] . _(' unmonitored hosts present')
				)
			);
		}
	}
});
