<?php

/**
 * Specialized checkbox widget for selecting a user's permissions
 */
class Enable_access_Nacomawidget extends Base_Nacomawidget {

	/**
	 * @return string
	 */
	private function _render_javascript() {
		$js = <<<JS
<script>
$(function() {
	// Hide access stuff on load
	var access_rows = $('.password_row, .groups_row, .realname_row, .modules_row')
	var all_rows = access_rows.add('.enable_access_row');
	access_rows.hide();
	$('.enable_access_widget').click(function() {
		var checkbox = $(this);

		// Enable the hidden access rights-config
		if(checkbox.get(0).checked) {
			if($.browser.msie) {
				access_rows.show();
			} else {
				access_rows.fadeIn();
			}
			all_rows.addClass("highlighted_row");
		} else {
			if($.browser.msie) {
				access_rows.hide();
			} else {
				access_rows.fadeOut();
			}
			all_rows.removeClass("highlighted_row");
		}
	});

	// Trigger on load when back button is used
	if($('.enable_access_widget:checked').length) {
		// we want the event handler but not the click, hence the restored the state
		$('.enable_access_widget')
			.trigger('click')
			.attr('checked', 'checked');
	}
});
</script>
JS;
		return $js;
	}

	/**
	 * @param $obj object_nacoma_Model
	 * @param $token
	 * @param $value string
	 */
	function render($obj, $token, $value) {
		$html = '<label><input type="checkbox" class="enable_access_widget" name="'.$this->get_id($obj, $token).'" id="'.$this->get_id($obj, $token).'" value="1" /> Configure access rights for this contact</label>';
		echo $html;
		echo $this->_render_javascript();
	}

	/**
	 * @param $obj object_nacoma_Model
	 * @param $token
	 * @param $value string
	 */
	static function validate($obj, $token, $value) {
		return $value;
	}
}
